import{s as he,n as ce,o as ue}from"../chunks/scheduler.6062bdaf.js";import{S as pe,i as fe,g as s,s as n,r as F,A as de,h as r,f as a,c as o,j as re,u as N,x as l,k as le,y as ge,a as i,v as O,d as B,t as J,w as K}from"../chunks/index.4bca734e.js";import{H as Q}from"../chunks/Heading.723dceba.js";function me(V){let h,P,$,k,c,L,u,X=`The <code>huggingface_hub</code> library is a library for interacting with the Hugging Face Hub, which is a
collections of git-based repositories (models, datasets or Spaces). There are two main
ways to access the Hub using <code>huggingface_hub</code>.`,M,p,Y=`The first approach, the so-called “git-based” approach, is led by the <a href="/docs/huggingface_hub/main/en/package_reference/repository#huggingface_hub.Repository">Repository</a> class.
This method uses a wrapper around the <code>git</code> command with additional functions specifically
designed to interact with the Hub. The second option, called the “HTTP-based” approach,
involves making HTTP requests using the <a href="/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi">HfApi</a> client. Let’s examine the pros and cons
of each approach.`,A,f,R,d,Z=`At first, <code>huggingface_hub</code> was mostly built around the <a href="/docs/huggingface_hub/main/en/package_reference/repository#huggingface_hub.Repository">Repository</a> class. It provides
Python wrappers for common <code>git</code> commands such as <code>&quot;git add&quot;</code>, <code>&quot;git commit&quot;</code>, <code>&quot;git push&quot;</code>,
<code>&quot;git tag&quot;</code>, <code>&quot;git checkout&quot;</code>, etc.`,q,g,ee=`The library also helps with setting credentials and tracking large files, which are often
used in machine learning repositories. Additionally, the library allows you to execute its
methods in the background, making it useful for uploading data during training.`,C,m,te=`The main advantage of using a <a href="/docs/huggingface_hub/main/en/package_reference/repository#huggingface_hub.Repository">Repository</a> is that it allows you to maintain a local
copy of the entire repository on your machine. This can also be a disadvantage as
it requires you to constantly update and maintain this local copy. This is similar to
traditional software development where each developer maintains their own local copy and
pushes changes when working on a feature. However, in the context of machine learning,
this may not always be necessary as users may only need to download weights for inference
or convert weights from one format to another without the need to clone the entire
repository.`,I,b,S,y,ae=`The <a href="/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi">HfApi</a> class was developed to provide an alternative to local git repositories, which
can be cumbersome to maintain, especially when dealing with large models or datasets. The
<a href="/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi">HfApi</a> class offers the same functionality as git-based approaches, such as downloading
and pushing files and creating branches and tags, but without the need for a local folder
that needs to be kept in sync.`,j,_,ie=`In addition to the functionalities already provided by <code>git</code>, the <a href="/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi">HfApi</a> class offers
additional features, such as the ability to manage repos, download files using caching for
efficient reuse, search the Hub for repos and metadata, access community features such as
discussions, PRs, and comments, and configure Spaces hardware and secrets.`,z,w,E,v,ne=`Overall, the <strong>HTTP-based approach is the recommended way to use</strong> <code>huggingface_hub</code>
in most cases. However, there are a few situations where maintaining a local git clone
(using <a href="/docs/huggingface_hub/main/en/package_reference/repository#huggingface_hub.Repository">Repository</a>) may be more beneficial:`,W,T,oe=`<li>If you are training a model on your machine, it may be more efficient to use a traditional
git-based workflow, pushing regular updates. <a href="/docs/huggingface_hub/main/en/package_reference/repository#huggingface_hub.Repository">Repository</a> is optimized for this type of
situation with its ability to work in the background.</li> <li>If you need to manually edit large files, <code>git</code> is the best option as it only sends the
diff to the server. With the <code>HfAPI</code> client, the entire file is uploaded with each edit.
Do keep in mind that most large files are binary so do not benefit from git diffs anyway.</li>`,G,H,se=`Not all git commands are available through <a href="/docs/huggingface_hub/main/en/package_reference/hf_api#huggingface_hub.HfApi">HfApi</a>. Some may never be implemented, but
we are always trying to improve and close the gap. If you don’t see your use case covered,
please open <a href="https://github.com/huggingface/huggingface_hub" rel="nofollow">an issue on Github</a>! We
welcome feedback to help build the 🤗 ecosystem with and for our users.`,U,x,D;return c=new Q({props:{title:"Git vs HTTP paradigm",local:"git-vs-http-paradigm",headingTag:"h1"}}),f=new Q({props:{title:"Repository: the historical git-based approach",local:"repository-the-historical-git-based-approach",headingTag:"h2"}}),b=new Q({props:{title:"HfApi: a flexible and convenient HTTP client",local:"hfapi-a-flexible-and-convenient-http-client",headingTag:"h2"}}),w=new Q({props:{title:"What should I use ? And when ?",local:"what-should-i-use--and-when-",headingTag:"h2"}}),{c(){h=s("meta"),P=n(),$=s("p"),k=n(),F(c.$$.fragment),L=n(),u=s("p"),u.innerHTML=X,M=n(),p=s("p"),p.innerHTML=Y,A=n(),F(f.$$.fragment),R=n(),d=s("p"),d.innerHTML=Z,q=n(),g=s("p"),g.textContent=ee,C=n(),m=s("p"),m.innerHTML=te,I=n(),F(b.$$.fragment),S=n(),y=s("p"),y.innerHTML=ae,j=n(),_=s("p"),_.innerHTML=ie,z=n(),F(w.$$.fragment),E=n(),v=s("p"),v.innerHTML=ne,W=n(),T=s("ul"),T.innerHTML=oe,G=n(),H=s("p"),H.innerHTML=se,U=n(),x=s("p"),this.h()},l(e){const t=de("svelte-u9bgzb",document.head);h=r(t,"META",{name:!0,content:!0}),t.forEach(a),P=o(e),$=r(e,"P",{}),re($).forEach(a),k=o(e),N(c.$$.fragment,e),L=o(e),u=r(e,"P",{"data-svelte-h":!0}),l(u)!=="svelte-109fppz"&&(u.innerHTML=X),M=o(e),p=r(e,"P",{"data-svelte-h":!0}),l(p)!=="svelte-udnnu9"&&(p.innerHTML=Y),A=o(e),N(f.$$.fragment,e),R=o(e),d=r(e,"P",{"data-svelte-h":!0}),l(d)!=="svelte-4k0jhw"&&(d.innerHTML=Z),q=o(e),g=r(e,"P",{"data-svelte-h":!0}),l(g)!=="svelte-mpix11"&&(g.textContent=ee),C=o(e),m=r(e,"P",{"data-svelte-h":!0}),l(m)!=="svelte-b0wyfz"&&(m.innerHTML=te),I=o(e),N(b.$$.fragment,e),S=o(e),y=r(e,"P",{"data-svelte-h":!0}),l(y)!=="svelte-1v5bf2u"&&(y.innerHTML=ae),j=o(e),_=r(e,"P",{"data-svelte-h":!0}),l(_)!=="svelte-1hj1jj0"&&(_.innerHTML=ie),z=o(e),N(w.$$.fragment,e),E=o(e),v=r(e,"P",{"data-svelte-h":!0}),l(v)!=="svelte-18f8hz2"&&(v.innerHTML=ne),W=o(e),T=r(e,"UL",{"data-svelte-h":!0}),l(T)!=="svelte-cx8prh"&&(T.innerHTML=oe),G=o(e),H=r(e,"P",{"data-svelte-h":!0}),l(H)!=="svelte-d2b0cb"&&(H.innerHTML=se),U=o(e),x=r(e,"P",{}),re(x).forEach(a),this.h()},h(){le(h,"name","hf:doc:metadata"),le(h,"content",be)},m(e,t){ge(document.head,h),i(e,P,t),i(e,$,t),i(e,k,t),O(c,e,t),i(e,L,t),i(e,u,t),i(e,M,t),i(e,p,t),i(e,A,t),O(f,e,t),i(e,R,t),i(e,d,t),i(e,q,t),i(e,g,t),i(e,C,t),i(e,m,t),i(e,I,t),O(b,e,t),i(e,S,t),i(e,y,t),i(e,j,t),i(e,_,t),i(e,z,t),O(w,e,t),i(e,E,t),i(e,v,t),i(e,W,t),i(e,T,t),i(e,G,t),i(e,H,t),i(e,U,t),i(e,x,t),D=!0},p:ce,i(e){D||(B(c.$$.fragment,e),B(f.$$.fragment,e),B(b.$$.fragment,e),B(w.$$.fragment,e),D=!0)},o(e){J(c.$$.fragment,e),J(f.$$.fragment,e),J(b.$$.fragment,e),J(w.$$.fragment,e),D=!1},d(e){e&&(a(P),a($),a(k),a(L),a(u),a(M),a(p),a(A),a(R),a(d),a(q),a(g),a(C),a(m),a(I),a(S),a(y),a(j),a(_),a(z),a(E),a(v),a(W),a(T),a(G),a(H),a(U),a(x)),a(h),K(c,e),K(f,e),K(b,e),K(w,e)}}}const be='{"title":"Git vs HTTP paradigm","local":"git-vs-http-paradigm","sections":[{"title":"Repository: the historical git-based approach","local":"repository-the-historical-git-based-approach","sections":[],"depth":2},{"title":"HfApi: a flexible and convenient HTTP client","local":"hfapi-a-flexible-and-convenient-http-client","sections":[],"depth":2},{"title":"What should I use ? And when ?","local":"what-should-i-use--and-when-","sections":[],"depth":2}],"depth":1}';function ye(V){return ue(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Te extends pe{constructor(h){super(),fe(this,h,ye,me,he,{})}}export{Te as component};
