import{s as Ti,n as wi,o as Li}from"../chunks/scheduler.6062bdaf.js";import{S as Ei,i as Mi,g as o,s as n,r as u,A as xi,h as s,f as i,c as a,j as bi,u as f,x as r,k as vi,y as yi,a as l,v as h,d as p,t as d,w as g}from"../chunks/index.4bca734e.js";import{H as m}from"../chunks/Heading.723dceba.js";function Ci(Nt){let c,Ee,we,Me,_,xe,H,St="<code>huggingface_hub</code> can be configured using environment variables.",ye,$,Bt=`If you are unfamiliar with environment variable, here are generic articles about them
<a href="https://linuxize.com/post/how-to-set-and-list-environment-variables-in-linux/" rel="nofollow">on macOS and Linux</a>
and on <a href="https://phoenixnap.com/kb/windows-set-environment-variable" rel="nofollow">Windows</a>.`,Ce,b,qt=`This page will guide you through all environment variables specific to <code>huggingface_hub</code>
and their meaning.`,Ie,v,Pe,T,Fe,w,Ot=`To configure the Hub base url. You might want to set this variable if your organization
is using a <a href="https://huggingface.co/platform" rel="nofollow">Private Hub</a>.`,Ae,L,Ut="Defaults to <code>&quot;https://huggingface.co&quot;</code>.",Ne,E,Se,M,Gt=`To configure the inference api base url. You might want to set this variable if your organization
is pointing at an API Gateway rather than directly at the inference api.`,Be,x,kt="Defaults to <code>&quot;https://api-inference.huggingface.com&quot;</code>.",qe,y,Oe,C,Rt=`To configure where <code>huggingface_hub</code> will locally store data. In particular, your token
and the cache will be stored in this folder.`,Ue,I,Dt='Defaults to <code>&quot;~/.cache/huggingface&quot;</code> unless <a href="#xdgcachehome">XDG_CACHE_HOME</a> is set.',Ge,P,ke,F,Yt=`To configure where repositories from the Hub will be cached locally (models, datasets and
spaces).`,Re,A,zt="Defaults to <code>&quot;$HF_HOME/hub&quot;</code> (e.g. <code>&quot;~/.cache/huggingface/hub&quot;</code> by default).",De,N,Ye,S,Kt=`To configure where <a href="../guides/manage-cache#caching-assets">assets</a> created by downstream libraries
will be cached locally. Those assets can be preprocessed data, files downloaded from GitHub,
logs,…`,ze,B,Wt="Defaults to <code>&quot;$HF_HOME/assets&quot;</code> (e.g. <code>&quot;~/.cache/huggingface/assets&quot;</code> by default).",Ke,q,We,O,Xt=`To configure the User Access Token to authenticate to the Hub. If set, this value will
overwrite the token stored on the machine (in <code>&quot;$HF_HOME/token&quot;</code>).`,Xe,U,jt='See <a href="../package_reference/login">login reference</a> for more details.',je,G,Ve,k,Vt=`Set the verbosity level of the <code>huggingface_hub</code>’s logger. Must be one of
<code>{&quot;debug&quot;, &quot;info&quot;, &quot;warning&quot;, &quot;error&quot;, &quot;critical&quot;}</code>.`,Je,R,Jt="Defaults to <code>&quot;warning&quot;</code>.",Qe,D,Qt='For more details, see <a href="../package_reference/utilities#huggingface_hub.utils.logging.get_verbosity">logging reference</a>.',Ze,Y,et,z,Zt=`Integer value to define under which size a file is considered as “small”. When downloading files to a local directory,
small files will be duplicated to ease user experience while bigger files are symlinked to save disk usage.`,tt,K,ei='For more details, see the <a href="../guides/download#download-files-to-local-folder">download guide</a>.',it,W,lt,X,ti=`The following environment variables expect a boolean value. The variable will be considered
as <code>True</code> if its value is one of <code>{&quot;1&quot;, &quot;ON&quot;, &quot;YES&quot;, &quot;TRUE&quot;}</code> (case-insensitive). Any other value
(or undefined) will be considered as <code>False</code>.`,nt,j,at,V,ii=`If set, no HTTP calls will me made when trying to fetch files. Only files that are already
cached will be accessed. This is useful in case your network is slow and you don’t care
about having absolutely the latest version of a file.`,ot,J,li=`<strong>Note:</strong> even if the latest version of a file is cached, calling <code>hf_hub_download</code> still triggers
a HTTP request to check that a new version is not available. Setting <code>HF_HUB_OFFLINE=1</code> will
skip this call which speeds up your loading time.`,st,Q,rt,Z,ni=`Authentication is not mandatory for every requests to the Hub. For instance, requesting
details about <code>&quot;gpt2&quot;</code> model does not require to be authenticated. However, if a user is
<a href="../package_reference/login">logged in</a>, the default behavior will be to always send the token
in order to ease user experience (never get a HTTP 401 Unauthorized) when accessing private or gated repositories. For privacy, you can
disable this behavior by setting <code>HF_HUB_DISABLE_IMPLICIT_TOKEN=1</code>. In this case,
the token will be sent only for “write-access” calls (example: create a commit).`,ut,ee,ai=`<strong>Note:</strong> disabling implicit sending of token can have weird side effects. For example,
if you want to list all models on the Hub, your private models will not be listed. You
would need to explicitly pass <code>token=True</code> argument in your script.`,ft,te,ht,ie,oi=`For time consuming tasks, <code>huggingface_hub</code> displays a progress bar by default (using tqdm).
You can disable all the progress bars at once by setting <code>HF_HUB_DISABLE_PROGRESS_BARS=1</code>.`,pt,le,dt,ne,si=`If you are on a Windows machine, it is recommended to enable the developer mode or to run
<code>huggingface_hub</code> in admin mode. If not, <code>huggingface_hub</code> will not be able to create
symlinks in your cache system. You will be able to execute any script but your user experience
will be degraded as some huge files might end-up duplicated on your hard-drive. A warning
message is triggered to warn you about this behavior. Set <code>HF_HUB_DISABLE_SYMLINKS_WARNING=1</code>,
to disable this warning.`,gt,ae,ri='For more details, see <a href="../guides/manage-cache#limitations">cache limitations</a>.',mt,oe,ct,se,ui=`Some features of <code>huggingface_hub</code> are experimental. This means you can use them but we do not guarantee they will be
maintained in the future. In particular, we might update the API or behavior of such features without any deprecation
cycle. A warning message is triggered when using an experimental feature to warn you about it. If you’re comfortable debugging any potential issues using an experimental feature, you can set <code>HF_HUB_DISABLE_EXPERIMENTAL_WARNING=1</code> to disable the warning.`,_t,re,fi="If you are using an experimental feature, please let us know! Your feedback can help us design and improve it.",Ht,ue,$t,fe,hi=`By default, some data is collected by HF libraries (<code>transformers</code>, <code>datasets</code>, <code>gradio</code>,..) to monitor usage, debug issues and help prioritize features.
Each library defines its own policy (i.e. which usage to monitor) but the core implementation happens in <code>huggingface_hub</code> (see <code>send_telemetry</code>).`,bt,he,pi="You can set <code>HF_HUB_DISABLE_TELEMETRY=1</code> as environment variable to globally disable telemetry.",vt,pe,Tt,de,di=`Set to <code>True</code> to download files from the Hub using <code>hf_transfer</code>. It’s a Rust-based package
that enables faster download (up to x2 speed-up). Be aware that this is still experimental
so it might cause issues in your workflow. In particular, it does not support features such
as progress bars, resume download, proxies or error handling.`,wt,ge,gi='<strong>Note:</strong> <code>hf_transfer</code> has to be installed separately <a href="https://pypi.org/project/hf-transfer/" rel="nofollow">from Pypi</a>.',Lt,me,Et,ce,mi=`Some environment variables are not specific to <code>huggingface_hub</code> but still taken into account
when they are set.`,Mt,_e,xt,He,ci=`Boolean value. When set, <code>huggingface-cli</code> tool will not print any ANSI color.
See <a href="https://no-color.org/" rel="nofollow">no-color.org</a>.`,yt,$e,Ct,be,_i="Used only when <code>HF_HOME</code> is not set!",It,ve,Hi=`This is the default way to configure where <a href="https://wiki.archlinux.org/title/XDG_Base_Directory" rel="nofollow">user-specific non-essential (cached) data should be written</a>
on linux machines.`,Pt,Te,$i=`If <code>HF_HOME</code> is not set, the default home will be <code>&quot;$XDG_CACHE_HOME/huggingface&quot;</code> instead
of <code>&quot;~/.cache/huggingface&quot;</code>.`,Ft,Le,At;return _=new m({props:{title:"Environment variables",local:"environment-variables",headingTag:"h1"}}),v=new m({props:{title:"Generic",local:"generic",headingTag:"h2"}}),T=new m({props:{title:"HF_ENDPOINT",local:"hfendpoint",headingTag:"h3"}}),E=new m({props:{title:"HF_INFERENCE_ENDPOINT",local:"hfinferenceendpoint",headingTag:"h3"}}),y=new m({props:{title:"HF_HOME",local:"hfhome",headingTag:"h3"}}),P=new m({props:{title:"HUGGINGFACE_HUB_CACHE",local:"huggingfacehubcache",headingTag:"h3"}}),N=new m({props:{title:"HUGGINGFACE_ASSETS_CACHE",local:"huggingfaceassetscache",headingTag:"h3"}}),q=new m({props:{title:"HUGGING_FACE_HUB_TOKEN",local:"huggingfacehubtoken",headingTag:"h3"}}),G=new m({props:{title:"HUGGINGFACE_HUB_VERBOSITY",local:"huggingfacehubverbosity",headingTag:"h3"}}),Y=new m({props:{title:"HF_HUB_LOCAL_DIR_AUTO_SYMLINK_THRESHOLD",local:"hfhublocaldirautosymlinkthreshold",headingTag:"h3"}}),W=new m({props:{title:"Boolean values",local:"boolean-values",headingTag:"h2"}}),j=new m({props:{title:"HF_HUB_OFFLINE",local:"hfhuboffline",headingTag:"h3"}}),Q=new m({props:{title:"HF_HUB_DISABLE_IMPLICIT_TOKEN",local:"hfhubdisableimplicittoken",headingTag:"h3"}}),te=new m({props:{title:"HF_HUB_DISABLE_PROGRESS_BARS",local:"hfhubdisableprogressbars",headingTag:"h3"}}),le=new m({props:{title:"HF_HUB_DISABLE_SYMLINKS_WARNING",local:"hfhubdisablesymlinkswarning",headingTag:"h3"}}),oe=new m({props:{title:"HF_HUB_DISABLE_EXPERIMENTAL_WARNING",local:"hfhubdisableexperimentalwarning",headingTag:"h3"}}),ue=new m({props:{title:"HF_HUB_DISABLE_TELEMETRY",local:"hfhubdisabletelemetry",headingTag:"h3"}}),pe=new m({props:{title:"HF_HUB_ENABLE_HF_TRANSFER",local:"hfhubenablehftransfer",headingTag:"h3"}}),me=new m({props:{title:"From external tools",local:"from-external-tools",headingTag:"h2"}}),_e=new m({props:{title:"NO_COLOR",local:"nocolor",headingTag:"h3"}}),$e=new m({props:{title:"XDG_CACHE_HOME",local:"xdgcachehome",headingTag:"h3"}}),{c(){c=o("meta"),Ee=n(),we=o("p"),Me=n(),u(_.$$.fragment),xe=n(),H=o("p"),H.innerHTML=St,ye=n(),$=o("p"),$.innerHTML=Bt,Ce=n(),b=o("p"),b.innerHTML=qt,Ie=n(),u(v.$$.fragment),Pe=n(),u(T.$$.fragment),Fe=n(),w=o("p"),w.innerHTML=Ot,Ae=n(),L=o("p"),L.innerHTML=Ut,Ne=n(),u(E.$$.fragment),Se=n(),M=o("p"),M.textContent=Gt,Be=n(),x=o("p"),x.innerHTML=kt,qe=n(),u(y.$$.fragment),Oe=n(),C=o("p"),C.innerHTML=Rt,Ue=n(),I=o("p"),I.innerHTML=Dt,Ge=n(),u(P.$$.fragment),ke=n(),F=o("p"),F.textContent=Yt,Re=n(),A=o("p"),A.innerHTML=zt,De=n(),u(N.$$.fragment),Ye=n(),S=o("p"),S.innerHTML=Kt,ze=n(),B=o("p"),B.innerHTML=Wt,Ke=n(),u(q.$$.fragment),We=n(),O=o("p"),O.innerHTML=Xt,Xe=n(),U=o("p"),U.innerHTML=jt,je=n(),u(G.$$.fragment),Ve=n(),k=o("p"),k.innerHTML=Vt,Je=n(),R=o("p"),R.innerHTML=Jt,Qe=n(),D=o("p"),D.innerHTML=Qt,Ze=n(),u(Y.$$.fragment),et=n(),z=o("p"),z.textContent=Zt,tt=n(),K=o("p"),K.innerHTML=ei,it=n(),u(W.$$.fragment),lt=n(),X=o("p"),X.innerHTML=ti,nt=n(),u(j.$$.fragment),at=n(),V=o("p"),V.textContent=ii,ot=n(),J=o("p"),J.innerHTML=li,st=n(),u(Q.$$.fragment),rt=n(),Z=o("p"),Z.innerHTML=ni,ut=n(),ee=o("p"),ee.innerHTML=ai,ft=n(),u(te.$$.fragment),ht=n(),ie=o("p"),ie.innerHTML=oi,pt=n(),u(le.$$.fragment),dt=n(),ne=o("p"),ne.innerHTML=si,gt=n(),ae=o("p"),ae.innerHTML=ri,mt=n(),u(oe.$$.fragment),ct=n(),se=o("p"),se.innerHTML=ui,_t=n(),re=o("p"),re.textContent=fi,Ht=n(),u(ue.$$.fragment),$t=n(),fe=o("p"),fe.innerHTML=hi,bt=n(),he=o("p"),he.innerHTML=pi,vt=n(),u(pe.$$.fragment),Tt=n(),de=o("p"),de.innerHTML=di,wt=n(),ge=o("p"),ge.innerHTML=gi,Lt=n(),u(me.$$.fragment),Et=n(),ce=o("p"),ce.innerHTML=mi,Mt=n(),u(_e.$$.fragment),xt=n(),He=o("p"),He.innerHTML=ci,yt=n(),u($e.$$.fragment),Ct=n(),be=o("p"),be.innerHTML=_i,It=n(),ve=o("p"),ve.innerHTML=Hi,Pt=n(),Te=o("p"),Te.innerHTML=$i,Ft=n(),Le=o("p"),this.h()},l(e){const t=xi("svelte-u9bgzb",document.head);c=s(t,"META",{name:!0,content:!0}),t.forEach(i),Ee=a(e),we=s(e,"P",{}),bi(we).forEach(i),Me=a(e),f(_.$$.fragment,e),xe=a(e),H=s(e,"P",{"data-svelte-h":!0}),r(H)!=="svelte-1xuew16"&&(H.innerHTML=St),ye=a(e),$=s(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1by1ave"&&($.innerHTML=Bt),Ce=a(e),b=s(e,"P",{"data-svelte-h":!0}),r(b)!=="svelte-5z5k2g"&&(b.innerHTML=qt),Ie=a(e),f(v.$$.fragment,e),Pe=a(e),f(T.$$.fragment,e),Fe=a(e),w=s(e,"P",{"data-svelte-h":!0}),r(w)!=="svelte-gfh3ro"&&(w.innerHTML=Ot),Ae=a(e),L=s(e,"P",{"data-svelte-h":!0}),r(L)!=="svelte-135fkrh"&&(L.innerHTML=Ut),Ne=a(e),f(E.$$.fragment,e),Se=a(e),M=s(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-178hqev"&&(M.textContent=Gt),Be=a(e),x=s(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-1jcmi14"&&(x.innerHTML=kt),qe=a(e),f(y.$$.fragment,e),Oe=a(e),C=s(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-uz9mxv"&&(C.innerHTML=Rt),Ue=a(e),I=s(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-1x0d3ca"&&(I.innerHTML=Dt),Ge=a(e),f(P.$$.fragment,e),ke=a(e),F=s(e,"P",{"data-svelte-h":!0}),r(F)!=="svelte-lfw4ab"&&(F.textContent=Yt),Re=a(e),A=s(e,"P",{"data-svelte-h":!0}),r(A)!=="svelte-a5p60a"&&(A.innerHTML=zt),De=a(e),f(N.$$.fragment,e),Ye=a(e),S=s(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-ksjawo"&&(S.innerHTML=Kt),ze=a(e),B=s(e,"P",{"data-svelte-h":!0}),r(B)!=="svelte-3wzlwo"&&(B.innerHTML=Wt),Ke=a(e),f(q.$$.fragment,e),We=a(e),O=s(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-dnq5h3"&&(O.innerHTML=Xt),Xe=a(e),U=s(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-1b9lbbx"&&(U.innerHTML=jt),je=a(e),f(G.$$.fragment,e),Ve=a(e),k=s(e,"P",{"data-svelte-h":!0}),r(k)!=="svelte-t9rwl1"&&(k.innerHTML=Vt),Je=a(e),R=s(e,"P",{"data-svelte-h":!0}),r(R)!=="svelte-4zt9wc"&&(R.innerHTML=Jt),Qe=a(e),D=s(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-5rzz4d"&&(D.innerHTML=Qt),Ze=a(e),f(Y.$$.fragment,e),et=a(e),z=s(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-gmny4d"&&(z.textContent=Zt),tt=a(e),K=s(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-18kg6sw"&&(K.innerHTML=ei),it=a(e),f(W.$$.fragment,e),lt=a(e),X=s(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-1enkv8e"&&(X.innerHTML=ti),nt=a(e),f(j.$$.fragment,e),at=a(e),V=s(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-1ctbewt"&&(V.textContent=ii),ot=a(e),J=s(e,"P",{"data-svelte-h":!0}),r(J)!=="svelte-insvpu"&&(J.innerHTML=li),st=a(e),f(Q.$$.fragment,e),rt=a(e),Z=s(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-1gxpflx"&&(Z.innerHTML=ni),ut=a(e),ee=s(e,"P",{"data-svelte-h":!0}),r(ee)!=="svelte-d0rh1g"&&(ee.innerHTML=ai),ft=a(e),f(te.$$.fragment,e),ht=a(e),ie=s(e,"P",{"data-svelte-h":!0}),r(ie)!=="svelte-192tmol"&&(ie.innerHTML=oi),pt=a(e),f(le.$$.fragment,e),dt=a(e),ne=s(e,"P",{"data-svelte-h":!0}),r(ne)!=="svelte-1a5ggf9"&&(ne.innerHTML=si),gt=a(e),ae=s(e,"P",{"data-svelte-h":!0}),r(ae)!=="svelte-1wsb5xe"&&(ae.innerHTML=ri),mt=a(e),f(oe.$$.fragment,e),ct=a(e),se=s(e,"P",{"data-svelte-h":!0}),r(se)!=="svelte-16gkjc3"&&(se.innerHTML=ui),_t=a(e),re=s(e,"P",{"data-svelte-h":!0}),r(re)!=="svelte-140g1ix"&&(re.textContent=fi),Ht=a(e),f(ue.$$.fragment,e),$t=a(e),fe=s(e,"P",{"data-svelte-h":!0}),r(fe)!=="svelte-yphpce"&&(fe.innerHTML=hi),bt=a(e),he=s(e,"P",{"data-svelte-h":!0}),r(he)!=="svelte-h3tzls"&&(he.innerHTML=pi),vt=a(e),f(pe.$$.fragment,e),Tt=a(e),de=s(e,"P",{"data-svelte-h":!0}),r(de)!=="svelte-52ybex"&&(de.innerHTML=di),wt=a(e),ge=s(e,"P",{"data-svelte-h":!0}),r(ge)!=="svelte-1cuoqo0"&&(ge.innerHTML=gi),Lt=a(e),f(me.$$.fragment,e),Et=a(e),ce=s(e,"P",{"data-svelte-h":!0}),r(ce)!=="svelte-xfaoya"&&(ce.innerHTML=mi),Mt=a(e),f(_e.$$.fragment,e),xt=a(e),He=s(e,"P",{"data-svelte-h":!0}),r(He)!=="svelte-16nqegp"&&(He.innerHTML=ci),yt=a(e),f($e.$$.fragment,e),Ct=a(e),be=s(e,"P",{"data-svelte-h":!0}),r(be)!=="svelte-38e7oi"&&(be.innerHTML=_i),It=a(e),ve=s(e,"P",{"data-svelte-h":!0}),r(ve)!=="svelte-h7vnjr"&&(ve.innerHTML=Hi),Pt=a(e),Te=s(e,"P",{"data-svelte-h":!0}),r(Te)!=="svelte-hhj9xt"&&(Te.innerHTML=$i),Ft=a(e),Le=s(e,"P",{}),bi(Le).forEach(i),this.h()},h(){vi(c,"name","hf:doc:metadata"),vi(c,"content",Ii)},m(e,t){yi(document.head,c),l(e,Ee,t),l(e,we,t),l(e,Me,t),h(_,e,t),l(e,xe,t),l(e,H,t),l(e,ye,t),l(e,$,t),l(e,Ce,t),l(e,b,t),l(e,Ie,t),h(v,e,t),l(e,Pe,t),h(T,e,t),l(e,Fe,t),l(e,w,t),l(e,Ae,t),l(e,L,t),l(e,Ne,t),h(E,e,t),l(e,Se,t),l(e,M,t),l(e,Be,t),l(e,x,t),l(e,qe,t),h(y,e,t),l(e,Oe,t),l(e,C,t),l(e,Ue,t),l(e,I,t),l(e,Ge,t),h(P,e,t),l(e,ke,t),l(e,F,t),l(e,Re,t),l(e,A,t),l(e,De,t),h(N,e,t),l(e,Ye,t),l(e,S,t),l(e,ze,t),l(e,B,t),l(e,Ke,t),h(q,e,t),l(e,We,t),l(e,O,t),l(e,Xe,t),l(e,U,t),l(e,je,t),h(G,e,t),l(e,Ve,t),l(e,k,t),l(e,Je,t),l(e,R,t),l(e,Qe,t),l(e,D,t),l(e,Ze,t),h(Y,e,t),l(e,et,t),l(e,z,t),l(e,tt,t),l(e,K,t),l(e,it,t),h(W,e,t),l(e,lt,t),l(e,X,t),l(e,nt,t),h(j,e,t),l(e,at,t),l(e,V,t),l(e,ot,t),l(e,J,t),l(e,st,t),h(Q,e,t),l(e,rt,t),l(e,Z,t),l(e,ut,t),l(e,ee,t),l(e,ft,t),h(te,e,t),l(e,ht,t),l(e,ie,t),l(e,pt,t),h(le,e,t),l(e,dt,t),l(e,ne,t),l(e,gt,t),l(e,ae,t),l(e,mt,t),h(oe,e,t),l(e,ct,t),l(e,se,t),l(e,_t,t),l(e,re,t),l(e,Ht,t),h(ue,e,t),l(e,$t,t),l(e,fe,t),l(e,bt,t),l(e,he,t),l(e,vt,t),h(pe,e,t),l(e,Tt,t),l(e,de,t),l(e,wt,t),l(e,ge,t),l(e,Lt,t),h(me,e,t),l(e,Et,t),l(e,ce,t),l(e,Mt,t),h(_e,e,t),l(e,xt,t),l(e,He,t),l(e,yt,t),h($e,e,t),l(e,Ct,t),l(e,be,t),l(e,It,t),l(e,ve,t),l(e,Pt,t),l(e,Te,t),l(e,Ft,t),l(e,Le,t),At=!0},p:wi,i(e){At||(p(_.$$.fragment,e),p(v.$$.fragment,e),p(T.$$.fragment,e),p(E.$$.fragment,e),p(y.$$.fragment,e),p(P.$$.fragment,e),p(N.$$.fragment,e),p(q.$$.fragment,e),p(G.$$.fragment,e),p(Y.$$.fragment,e),p(W.$$.fragment,e),p(j.$$.fragment,e),p(Q.$$.fragment,e),p(te.$$.fragment,e),p(le.$$.fragment,e),p(oe.$$.fragment,e),p(ue.$$.fragment,e),p(pe.$$.fragment,e),p(me.$$.fragment,e),p(_e.$$.fragment,e),p($e.$$.fragment,e),At=!0)},o(e){d(_.$$.fragment,e),d(v.$$.fragment,e),d(T.$$.fragment,e),d(E.$$.fragment,e),d(y.$$.fragment,e),d(P.$$.fragment,e),d(N.$$.fragment,e),d(q.$$.fragment,e),d(G.$$.fragment,e),d(Y.$$.fragment,e),d(W.$$.fragment,e),d(j.$$.fragment,e),d(Q.$$.fragment,e),d(te.$$.fragment,e),d(le.$$.fragment,e),d(oe.$$.fragment,e),d(ue.$$.fragment,e),d(pe.$$.fragment,e),d(me.$$.fragment,e),d(_e.$$.fragment,e),d($e.$$.fragment,e),At=!1},d(e){e&&(i(Ee),i(we),i(Me),i(xe),i(H),i(ye),i($),i(Ce),i(b),i(Ie),i(Pe),i(Fe),i(w),i(Ae),i(L),i(Ne),i(Se),i(M),i(Be),i(x),i(qe),i(Oe),i(C),i(Ue),i(I),i(Ge),i(ke),i(F),i(Re),i(A),i(De),i(Ye),i(S),i(ze),i(B),i(Ke),i(We),i(O),i(Xe),i(U),i(je),i(Ve),i(k),i(Je),i(R),i(Qe),i(D),i(Ze),i(et),i(z),i(tt),i(K),i(it),i(lt),i(X),i(nt),i(at),i(V),i(ot),i(J),i(st),i(rt),i(Z),i(ut),i(ee),i(ft),i(ht),i(ie),i(pt),i(dt),i(ne),i(gt),i(ae),i(mt),i(ct),i(se),i(_t),i(re),i(Ht),i($t),i(fe),i(bt),i(he),i(vt),i(Tt),i(de),i(wt),i(ge),i(Lt),i(Et),i(ce),i(Mt),i(xt),i(He),i(yt),i(Ct),i(be),i(It),i(ve),i(Pt),i(Te),i(Ft),i(Le)),i(c),g(_,e),g(v,e),g(T,e),g(E,e),g(y,e),g(P,e),g(N,e),g(q,e),g(G,e),g(Y,e),g(W,e),g(j,e),g(Q,e),g(te,e),g(le,e),g(oe,e),g(ue,e),g(pe,e),g(me,e),g(_e,e),g($e,e)}}}const Ii='{"title":"Environment variables","local":"environment-variables","sections":[{"title":"Generic","local":"generic","sections":[{"title":"HF_ENDPOINT","local":"hfendpoint","sections":[],"depth":3},{"title":"HF_INFERENCE_ENDPOINT","local":"hfinferenceendpoint","sections":[],"depth":3},{"title":"HF_HOME","local":"hfhome","sections":[],"depth":3},{"title":"HUGGINGFACE_HUB_CACHE","local":"huggingfacehubcache","sections":[],"depth":3},{"title":"HUGGINGFACE_ASSETS_CACHE","local":"huggingfaceassetscache","sections":[],"depth":3},{"title":"HUGGING_FACE_HUB_TOKEN","local":"huggingfacehubtoken","sections":[],"depth":3},{"title":"HUGGINGFACE_HUB_VERBOSITY","local":"huggingfacehubverbosity","sections":[],"depth":3},{"title":"HF_HUB_LOCAL_DIR_AUTO_SYMLINK_THRESHOLD","local":"hfhublocaldirautosymlinkthreshold","sections":[],"depth":3}],"depth":2},{"title":"Boolean values","local":"boolean-values","sections":[{"title":"HF_HUB_OFFLINE","local":"hfhuboffline","sections":[],"depth":3},{"title":"HF_HUB_DISABLE_IMPLICIT_TOKEN","local":"hfhubdisableimplicittoken","sections":[],"depth":3},{"title":"HF_HUB_DISABLE_PROGRESS_BARS","local":"hfhubdisableprogressbars","sections":[],"depth":3},{"title":"HF_HUB_DISABLE_SYMLINKS_WARNING","local":"hfhubdisablesymlinkswarning","sections":[],"depth":3},{"title":"HF_HUB_DISABLE_EXPERIMENTAL_WARNING","local":"hfhubdisableexperimentalwarning","sections":[],"depth":3},{"title":"HF_HUB_DISABLE_TELEMETRY","local":"hfhubdisabletelemetry","sections":[],"depth":3},{"title":"HF_HUB_ENABLE_HF_TRANSFER","local":"hfhubenablehftransfer","sections":[],"depth":3}],"depth":2},{"title":"From external tools","local":"from-external-tools","sections":[{"title":"NO_COLOR","local":"nocolor","sections":[],"depth":3},{"title":"XDG_CACHE_HOME","local":"xdgcachehome","sections":[],"depth":3}],"depth":2}],"depth":1}';function Pi(Nt){return Li(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Si extends Ei{constructor(c){super(),Mi(this,c,Pi,Ci,Ti,{})}}export{Si as component};
